require_relative 'rankable'

module Flicks
	class Movie
		include Rankable
		attr_accessor :title,:rank,:snack_carbs

		def initialize(title,rank=0)
			@title = title.capitalize
			@rank = rank
			@snack_carbs = Hash.new(0)
		end

		def self.convert(line)
			title,rank = line.split(",")
			return Movie.new(title,Integer(rank))
		end

		def to_csv
			"#{@title},#{@rank}"
		end

		def ate_snack(snack)
			@snack_carbs[snack.name] += snack.carbs
			puts "#{@title} led to #{snack.carbs} #{snack.name} carbs being consumed"
			puts "#{@title}'s consumed snacks: #{@snack_carbs}"
		end

		def each_snack
			@snack_carbs.each do |key,value|
				snack = Snack.new(key,Integer(value))
				yield snack
			end
		end

		def carbs_consumed 
			@snack_carbs.values.reduce(0) {|sum,n| sum + n }
		end

		def to_s
			"#{@title} has a rank of #{@rank} (#{status})"
		end

		class << self #or object name
			def whatsgood
				"Another way to define singleton method"
			end
		end

	end
end
if __FILE__ == $0
	# movie = Movie.new('goonies',10)
	# puts movie.title
	# puts movie.rank
	# puts movie.normalized_rank
	# puts movie.thumbs_up
	# puts movie.thumbs_down
	# puts movie
end 
